Index: ChangeLog
2006-04-10  Peter O'Gorman  <peter@pogma.com> (tiny change)

	* default.c (default_suffixes, default_suffix_rules, 
	default_variables): Defaults for objective-C.
	* doc/make.texi: Document new defaults.

from  Paul D. Smith  <psmith@gnu.org>
Index: default.c
===================================================================
RCS file: /sources/make/make/default.c,v
retrieving revision 1.48
diff -u -r1.48 default.c
--- default.c 9 Apr 2006 22:09:24 -0000 1.48
+++ default.c 20 Apr 2006 03:50:44 -0000
@@ -45,7 +45,7 @@
 .mod .sym .def .h .info .dvi .tex .texinfo .texi .txinfo \
 .w .ch .web .sh .elc .el .obj .exe .dll .lib";
 #else
-  = ".out .a .ln .o .c .cc .C .cpp .p .f .F .r .y .l .s .S \
+  = ".out .a .ln .o .c .cc .C .cpp .p .f .F .m .r .y .l .ym .lm .s .S \
 .mod .sym .def .h .info .dvi .tex .texinfo .texi .txinfo \
 .w .ch .web .sh .elc .el";
 #endif
@@ -192,6 +192,8 @@
     "$(LINK.cpp) $^ $(LOADLIBES) $(LDLIBS) -o $@",
     ".f",
     "$(LINK.f) $^ $(LOADLIBES) $(LDLIBS) -o $@",
+    ".m",
+    "$(LINK.m) $^ $(LOADLIBES) $(LDLIBS) -o $@",
     ".p",
     "$(LINK.p) $^ $(LOADLIBES) $(LDLIBS) -o $@",
     ".F",
@@ -221,6 +223,8 @@
     "$(COMPILE.cpp) $(OUTPUT_OPTION) $<",
     ".f.o",
     "$(COMPILE.f) $(OUTPUT_OPTION) $<",
+    ".m.o",
+    "$(COMPILE.m) $(OUTPUT_OPTION) $<",
     ".p.o",
     "$(COMPILE.p) $(OUTPUT_OPTION) $<",
     ".F.o",
@@ -249,7 +253,10 @@
 #endif
     ".l.c",
     "@$(RM) $@ \n $(LEX.l) $< > $@",
-
+    ".ym.m",
+    "$(YACC.m) $< \n mv -f y.tab.c $@",
+    ".lm.m",
+    "@$(RM) $@ \n $(LEX.m) $< > $@",
     ".F.f",
     "$(PREPROCESS.F) $(OUTPUT_OPTION) $<",
     ".r.f",
@@ -343,6 +350,12 @@
     "F77FLAGS", "$(FFLAGS)",
     "LD", "link",
     "LEX", "lex",
+#ifdef GCC_IS_NATIVE
+    "OBJC", "gcc",
+#else
+    "OBJC", "cc",
+#endif
+    "OBJCFLAGS", "$(CFLAGS)",
     "PC", "pascal",
     "YACC", "bison/yacc",
     "YFLAGS", "/Define/Verbose",
@@ -438,6 +451,12 @@
 #else
     "LEX", "lex",
 #endif
+#ifdef GCC_IS_NATIVE
+    "OBJC", "gcc",
+#else
+    "OBJC", "cc",
+#endif
+    "OBJCFLAGS", "$(CFLAGS)",
     "LINT", "lint",
     "M2C", "m2c",
 #ifdef	pyr
@@ -468,6 +487,8 @@
     "LINK.o", "$(CC) $(LDFLAGS) $(TARGET_ARCH)",
     "COMPILE.c", "$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c",
     "LINK.c", "$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH)",
+    "COMPILE.m", "$(OBJC) $(OBJCFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c",
+    "LINK.m", "$(OBJC) $(OBJCFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH)",
     "COMPILE.cc", "$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c",
     "COMPILE.C", "$(COMPILE.cc)",
     "COMPILE.cpp", "$(COMPILE.cc)",
@@ -476,6 +497,8 @@
     "LINK.cpp", "$(LINK.cc)",
     "YACC.y", "$(YACC) $(YFLAGS)",
     "LEX.l", "$(LEX) $(LFLAGS) -t",
+    "YACC.m", "$(YACC) $(YFLAGS)",
+    "LEX.m", "$(LEX) $(LFLAGS) -t",
     "COMPILE.f", "$(FC) $(FFLAGS) $(TARGET_ARCH) -c",
     "LINK.f", "$(FC) $(FFLAGS) $(LDFLAGS) $(TARGET_ARCH)",
     "COMPILE.F", "$(FC) $(FFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c",
Index: doc/make.texi
===================================================================
RCS file: /sources/make/make/doc/make.texi,v
retrieving revision 1.45
diff -u -r1.45 make.texi
--- doc/make.texi 1 Apr 2006 06:36:40 -0000 1.45
+++ doc/make.texi 20 Apr 2006 03:50:48 -0000
@@ -8353,16 +8353,16 @@
 the special target @code{.SUFFIXES}).  The default suffix list is:
 @code{.out}, @code{.a}, @code{.ln}, @code{.o}, @code{.c}, @code{.cc},
 @code{.C}, @code{.cpp}, @code{.p}, @code{.f}, @code{.F}, @code{.r}, @code{.y},
-@code{.l}, @code{.s}, @code{.S}, @code{.mod}, @code{.sym}, @code{.def},
-@code{.h}, @code{.info}, @code{.dvi}, @code{.tex}, @code{.texinfo},
-@code{.texi}, @code{.txinfo}, @code{.w}, @code{.ch} @code{.web},
-@code{.sh}, @code{.elc}, @code{.el}.  All of the implicit rules
-described below whose prerequisites have one of these suffixes are
-actually suffix rules.  If you modify the suffix list, the only
-predefined suffix rules in effect will be those named by one or two of
-the suffixes that are on the list you specify; rules whose suffixes fail
-to be on the list are disabled.  @xref{Suffix Rules, ,Old-Fashioned
-Suffix Rules}, for full details on suffix rules.
+@code{.l}, @code{.ym}, @code{.lm}, @code{.s}, @code{.S}, @code{.m},
+@code{.mod}, @code{.sym}, @code{.def}, @code{.h}, @code{.info}, @code{.dvi},
+@code{.tex}, @code{.texinfo}, @code{.texi}, @code{.txinfo}, @code{.w},
+@code{.ch} @code{.web}, @code{.sh}, @code{.elc}, @code{.el}.  All of the
+implicit rules described below whose prerequisites have one of these suffixes
+are actually suffix rules.  If you modify the suffix list, the only predefined
+suffix rules in effect will be those named by one or two of the suffixes that
+are on the list you specify; rules whose suffixes fail to be on the list are
+disabled.  @xref{Suffix Rules, ,Old-Fashioned Suffix Rules}, for full details
+on suffix rules.
 
 @table @asis
 @item Compiling C programs